/* CAD.H - Header for fake cad interface module */
/* (c) 1988 - University of Michigan */

#ifndef _H_CAD
#define _H_CAD

#ifndef _H_CONFIG
#include "config.h"
#endif _H_CONFIG

#ifndef _H_GLOBAL
#include "global.h"
#endif _H_GLOBAL

#ifndef _H_SET
#include "set.h"
#endif _H_SET

#define DATA CAD_MOD

/* Structure for linked list of constraints */

struct con {
	Traj tr;
	PartSet	*sp;
	struct con *next;
	};

struct rset {
	PartSet p;
	struct rset *next;
	};

/* Externals for use in cad module */

extern char p_name[MAXPARTS][(MAX_NAME_LENGTH+2) & ~1];
extern char d_name[MAXTRAJS][(MAX_NAME_LENGTH+2) & ~1];
extern char t_name[MAXTRAJS][(MAX_NAME_LENGTH+2) & ~1];
extern TrajSet *proposed[MAXPARTS];
extern PartSet *attach[MAXPARTS], *lift[MAXPARTS];
#ifdef CONTACT
extern PartSet *contact[MAXPARTS];
#endif CONTACT
extern struct rset *rotate[MAXPARTS];
extern int manip[MAXPARTS];
extern int diffic[MAXTRAJS];
extern TrajSet *dir_traj[MAXTRAJS];
extern struct con *constraint[MAXPARTS];

#endif _H_CAD
