/* CAD_CRIT.C  Interface to criteria weights database */
/* (c) 1988 - University of Michigan */

#include <stdio.h>
#include "config.h"
#include "global.h"

int read_val();
#define read_value(fp) read_val(fp,TRUE)

struct cw {
	char nm[MAX_NAME_LENGTH];
	int ew,pw;
	struct cw *next;
	} *first = NULL;

/* GETWEIGHTS(name,fp,eval,prop)
 * Look for an entry in the database file fp that matches the name given.
 * Return weights of 0 if none is found.
 */

getweights(name,fp,eval,prop)
char *name;
FILE *fp;
int *eval, *prop;
{
struct cw *ccw,*pcw;
char *tn, *next_word();

	if (is_on(SHOW_ENTRIES)) printf("getweights\n");

	/* See if we have already read it in */
	for (ccw = first,pcw=NULL; ccw != NULL; ccw = (pcw=ccw)->next)
		if (!strcmp(ccw->nm,name))
		{
			*eval = ccw->ew;
			*prop = ccw->pw;
			if (pcw)
				pcw->next = ccw->next;
			else
				first = ccw->next;
			m_free(ccw,sizeof(struct cw));
			return;
		}

	/* Read in some more */
	while (tn=next_word(fp))
		if (tn != (char *) 1)
			if (!strcmp(tn,name))
			{
				*eval = read_value(fp);
				*prop = read_value(fp);
				return;
			}
			else
			{
				ccw = (struct cw *)m_alloc(sizeof(struct cw));
				strcpy (ccw->nm,tn);
				ccw->ew = read_value(fp);
				ccw->pw = read_value(fp);
				ccw->next = first;
				first = ccw;
			}

	/* If we didn't find it, return 0 */
	*eval = *prop = 0;
}

dispose_weights()
{
struct cw *ccw,*ncw;

	if (is_on(SHOW_ENTRIES)) printf("dispose_weights\n");

	ccw = first;
	while (ccw != NULL)
	{
		ncw = ccw->next;
		m_free(ccw,sizeof(struct cw));
		ccw = ncw;
	}
	first = NULL;
}

#ifdef SIZE
long cad_weight_size()
{
long size = 0;
struct cw *ccw;

	for (ccw = first; ccw != NULL; ccw = ccw->next)
		size += sizeof(struct cw);
	return(size);
}
#endif SIZE
