/* CAD_DEBUG.C  Interface to debug output data base */
/* (c) 1988 - University of Michigan */

#include <stdio.h>
#include "config.h"
#include "global.h"
#define DATA DBUG_MOD

boolean debug_switch[N_SWITCHES];
boolean const_switch[N_SWITCHES];

struct ls {
        int leafid; 
        boolean sw[N_SWITCHES];
        struct ls *next; 
        } *sw_head; 
 
char *sw_name[N_SWITCHES] = {"PROP","RATE","TREE","LEAF","STAT","WEIGHT",
	"LIST","ENTRY","EXPAND","CONSTRAINTS","SOLUTION","BOUND","SIZE"};
char *next_word();

init_debug(fp) 
FILE *fp;
{
int i,j;
char *tn;
 
    sw_head = NULL; 
    for (i = 0; i< N_SWITCHES; i++)
	const_switch[i]=FALSE;

    if (!fp) return;

    while (tn=next_word(fp))
	if (tn != (char *)1)
	{
	    for (i=0;i<N_SWITCHES; i++)
		if (!strcmp(tn,sw_name[i]))
		{
		    if ((j=read_val(fp,FALSE)) < 0)
			const_switch[i]=TRUE;
		    else
			do
			    turn_leaf_on(j,i);
		    	while ((j=read_val(fp,FALSE)) >= 0);
		    break;
		}
	    if (i >= N_SWITCHES)
	    {
		if (*tn = '#')
		    while(next_word(fp) != (char *)1)
			;
		else
		    error("keyword %s unknown\n",tn);
	    }
	}
    leaf_switches(0);
}

turn_leaf_on(id,sw)
register int id,sw;
{
register struct ls *lsp,*plsp;
register int i;

    for (lsp=sw_head,plsp=NULL; lsp!=NULL; lsp=(plsp=lsp)->next)
    {
	if (lsp->leafid == id)
	{
	    lsp->sw[sw] = TRUE;
	    return;
	}
	if (lsp->leafid > id)
	    break;
    }
    lsp = (struct ls *) m_alloc(sizeof(struct ls));
    lsp->leafid = id;
    for (i = 0; i< N_SWITCHES; i++)
	lsp->sw[i] = FALSE;
    lsp->sw[sw] = TRUE;
    if (plsp == NULL)
    {
	lsp->next = sw_head;
	sw_head = lsp;
    }
    else
    {
	lsp->next = plsp->next;
	plsp->next = lsp;
    }
}

/* Set the switches to their setting for this leaf */
leaf_switches(id)
int id;
{
register struct ls *lsp;
register int i;

    for (lsp=sw_head; lsp!=NULL; lsp=lsp->next)
    {
	if (id == lsp->leafid)
	{
		for (i=0;i<N_SWITCHES; i++)
			debug_switch[i] = lsp->sw[i] || const_switch[i];
		return;
	}
    }
    for (i=0; i<N_SWITCHES; i++)
	debug_switch[i] = const_switch[i];
}


#ifdef SIZE
long cad_switch_size()
{
register struct ls *lsp;
long size = 0;

    for (lsp=sw_head; lsp!=NULL; lsp=lsp->next)
	size += sizeof(struct ls);
    return(size);
}
#endif SIZE
