/* CAD_DISP.C  routines to dispose of cad data structures after we are done
	       initializing system */
/* (c) 1988 - University of Michigan */

#include <stdio.h>
#include "config.h"
#include "global.h"
#include "cad.h"

dispose_cad()
{
register Part p;
register Dire d;
struct con *c,*n;
struct rset *rsp, *nrsp;

	if (is_on(SHOW_ENTRIES)) printf("dispose_cad\n");
	for (p=0; p<n_parts; p++)
	{
		/* Get rid of the constraint list */
		c=constraint[p];
		while (c != NULL)
		{
			n = c->next;
			freeset(c->sp);
			m_free(c,sizeof(struct con));
			c = n;
		}
		constraint[p] = NULL;

		/* Get rid of some sets */
		freeset(proposed[p]);
		freeset(attach[p]);
		freeset(lift[p]);
#ifdef CONNECT
		freeset(connect[p]);
#endif CONNECT
		rsp = rotate[p];
		while (rsp != NULL)
		{
			nrsp = rsp->next;
			m_free(rsp,sizeof(struct rset));
			rsp = nrsp;
		}
	}

	for (d=0; d<n_directions; d++)
	{
		freeset(dir_traj[d]);
		dir_traj[d] = NULL;
	}

	/* Get rid of anything left in the weights module */
	dispose_weights();
}
