/* CONFIG.H */
/* (c) 1988 - University of Michigan */

#ifndef _H_CONFIG
#define _H_CONFIG

#ifndef _H_VERSION
#include "version.h"
#endif _H_VERSION

/*                     "Hardware" Configuration:
 *
 * MEMLIMIT	This is a soft limit on the maximum amount of memory to use.
 *		It doesn't do anything at all unless BOUND or DISCARD are
 *		defined.  If one of these is defined (preferably the latter)
 *		it trys to free up memory if usage climbs above MEMLIMIT.
 *
 * LONG32	Longs are 32 bits long.
 *
 * NO_VARARGS	System does not support the <varargs.h> macros.  Don't really
 *		need them anyways.
 */

#ifdef SUN
#  define MEMLIMIT 500000
#  define LONG32
/*#  define NO_VARARGS	/* For testing only...remove this */
#endif SUN

#ifdef MAC
#  define MEMLIMIT 500000
#  define LONG32
#  define NO_VARARGS
#endif MAC

/*                    "Software" Configuration:
 *
 * setsize	A type for holding indexes for parts and trajectories.
 * MAXPARTS	Maximum number of parts in a problem.  This should be a
 *		multiple of four, and must fit in the setsize type.
 * MAXTRAJS	Maximum number of trajectories in a problem.  This should be
 *		a multiple of four, and must fit in the setsize type.
 *
 * MAX_NAME_LENGTH  Maximum length for the name of a part, trajectory, or
 *		direction.  Names are used for I/O only.
 *
 * RANGECHECK	If this is defined, all set operations preform checks to
 *		make sure the elements they refer to are within the legal
 *		range for that set.  It is an error if an element is out
 *		of range, and execution immediately stops.  This is for
 *		debugging only.
 *
 * m_alloc	Return an uninitialized block of memory at least the given
 *		size.  For now just use malloc, but this makes it easier to
 *		keep count of how much we've used.
 * m_free	Free a block of memory of the given size at the given
 *		location.
 */

#define MAXPARTS	40
#define MAXTRAJS	40
typedef char setsize;
#define MAX_NAME_LENGTH 40
#define RANGECHECK
char *m_alloc();
char *m_realloc();


#endif _H_CONFIG
