/* (c) 1988 - University of Michigan */
#include <stdio.h>
#include "assert.h"
#include "exec.h"

Prop *read_prop();

extern Leaf best;
char *dflt_wfile = "criteria";

main(argc,argv)
int argc;
char **argv;
{
FILE *in,*win;
char *wfile;
Prop *p;

        if (argc < 2 || argc > 3)
        {
                printf("usage: %s problem [criteria]\n",argv[0]);
                exit(1);
        }
        wfile = (argc == 3)? argv[2] : dflt_wfile;

        if ((in = fopen(argv[1],"r")) == NULL)
        {
                printf("cannot open %s\n",argv[1]);
                exit(1);
        }

        if ((win = fopen(wfile,"r")) == NULL)
        {
                printf("cannot open %s\n",wfile);
                exit(1);
        }
 
	initialize(in,win);
	fclose(in);
	printf("CONSTRAINTS:\n");
	dump_constraints(stdout,best);
	printf("\nINITIAL LEAF:\n");
	dump_fulltree(stdout);
	printf("\n");

	while (p=read_prop())
	{
		printf("\nPROPOSAL:\n");
		dump_prop(stdout,p);

		printf("\nCONSEQUENCES:\n");
		if (consequence(best,p))
		{
			printf("CONTRADICTION\n");
			exit(0);
		}

		best[DATA]->rating = crit_rate(best);
		best[DATA]->completion = acg_rate(best);
		printf("\nNEW LEAF:\n");
		dump_fulltree(stdout);
	}
}


Prop *read_prop()
{
static Prop p;
static SequProp s;
static TrajProp t;
int i;

	printf("(S) Sequencing or (T) Trajectory? ");
	if ((i=getlc()) == 'S')
	{
		p.type = SEQU;
		p.a.sequ = &s;
		printf("First Part Number: ");
		s.p1 = getlc()-'0';
		printf("Second Part Number: ");
		s.p2 = getlc()-'0';
		return(&p);
	}
	else if (i=='T')
	{
		p.type = TRAJ;
		p.a.traj = &t;
		printf("Part Number: ");
		t.p = getlc()-'0';
		emptytrajset(&t.t);
		for (;;)
		{
			printf("Trajectory (return to stop): ");
			if ((i=getlc()) == '\n') break;
			append1(&t.t,i-'0');
		}
		return(&p);
	}
	else
		return(NULL);
}

getlc()
{
int c1,c2;
	c1 = getchar();
	if (c1 == '\n' || c1 == EOF) return(c1);
	while ((c2 = getchar()) != '\n' && c2 != EOF)
		;
	return(c1);
}

/* Dummy entry points */
sfc_prop() {;}
